/*
 * TUNA-CAN FIRtB^R[h Visual DSP++p
 *
 * Copyright(C) 2012-2013 Kaneko System Co., Ltd.
 *
 * Last Update: 2013/04/08
 *
 * yӁz
 * EǂȂłRɉςĎgp邱Ƃł܂B
 * Ẽ\tgEFA͖ۏ؂łB̃t@CɋLڂĂER[h
 *   gpꍇ́A[U̐ӔCɂčsĂB̎gp
 *   NA[U܂͑O҂ɐQɊւAЂ͈؂̐ӔC
 *   ܂B
 *
 * yz
 *   FIRtB^g2000Hz-80dBLPF܂B
 *   AUDIO IN̉ƂȂAUDIO OUTo͂܂B
 *
 */

#include <blackfin.h>
#include <builtins.h>
#include <sys/exception.h>
#include <stdint.h>
#include <string.h>
#include <filter.h>

/* VXeNbN(99MHz) */
#define SCLOCK_HZ		(99000000)

#define TWI_COUNT(x) (DCNT & ((x) << 6))
/* TWIp߂l */
#define NO_ERROR		(0)
#define TWI_ERROR_NAK	(-1)
/* s_twi_master_writerstartp` */
#define TWI_STOP		(0)
#define TWI_RSTART		(1)

/* SGTL5000I2CfoCXAhX */
#define TWI_CODEC_DEVICE_ADDR	(0x0A)

/* 1`l1̃TvTCY */
#define NUM_SAMPLES		(128)
/* `l(XeI) */
#define NUM_CHANNEL		(2)
/* obt@O(_uobt@) */
#define NUM_BUFFERS		(2)

/* SPORT RX DMA荞݂̃vg^Cv錾 */
EX_INTERRUPT_HANDLER(s_sport_rx_isr);
/* I[fBIp֐ */
static void s_audio_process(const int32_t* p_left_rxbuf, const int32_t* p_right_rxbuf, int32_t* p_left_txbuf, int32_t* p_right_txbuf);

/* TWI(I2C)p֐ */
static void s_twi_init(void);
/* TWI(I2C)f[^Mp֐ */
static int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt);

/* GP^C}0荞݂̃vg^Cv錾 */
EX_INTERRUPT_HANDLER(s_gptimer_isr);

/* SPORTMobt@(_uobt@,2`l) */
static int32_t sf_sport_rxbuf[NUM_CHANNEL][NUM_BUFFERS][NUM_SAMPLES];
/* SPORTMobt@(_uobt@,2`l) */
static int32_t sf_sport_txbuf[NUM_CHANNEL][NUM_BUFFERS][NUM_SAMPLES];
/* DMAǂ̃obt@gpĂ邩 */
static volatile int32_t sf_sport_use_bufidx;

/* DMApfBXNv^ */
struct dma_large_desc_t
{
	uint32_t next_addr;
	uint32_t addr;
	uint16_t cfg;
	uint16_t xcnt;
	int16_t  xmod;
	uint16_t ycnt;
	int16_t  ymod;
};

static struct dma_large_desc_t sf_sport_rxdma_desc[NUM_BUFFERS];
static struct dma_large_desc_t sf_sport_txdma_desc[NUM_BUFFERS];

/* f[^]tO */
static volatile int32_t sf_data_incoming;

/* SGTL5000 TWIf[^ */
static const uint8_t sf_audio_init_data1[] =
{
	// Shutdown
	0x00, 0x02, 0x00, 0x00,	// CHIP_DIG Power     0000-0000 0000-0000
	0x00, 0x04, 0x00, 0x08,	// CHIP_CLK_CTRL      0000-0000 0000-1000
	0x00, 0x26, 0x00, 0x00,	// CHIP_LINREG_CTRL   0000-0000 0000-0000 VDDD = 1.6V
	0x00, 0x30, 0x72, 0x00,	// CHIP_ANA_POWER     0111-0010 0000-0000

	// Set up registers
	0x00, 0x06, 0x00, 0x80,	// CHIP_I2S_CTRL      0000-0000 1000-0000
	0x00, 0x0A, 0x00, 0x10,	// CHIP_SSS_CTRL      0000-0000 0001-0000
	0x00, 0x0E, 0x00, 0x00,	// CHIP_ADCDAC_CTRL   0000-0000 0000-0000
	0x00, 0x10, 0x3C, 0x3C,	// CHIP_DAC_VOL
	0x00, 0x14, 0x01, 0x55,	// CHIP_PAD_STRENGTH  0000-0001 0101-0101
	0x00, 0x20, 0x02, 0x00,	// CHIP_ANA_ADC_CTRL  0000-0010 0000-0000
	0x00, 0x22, 0x18, 0x18,	// CHIP_ANA_HP_CTRL
	0x00, 0x24, 0x00, 0x26,	// CHIP_ANA_CTRL      0000-0000 0010-0110
	0x00, 0x28, 0x00, 0x40,	// CHIP_REF_CTRL      0000-0000 0100-0000 VAG_VAL = 0.9V
	0x00, 0x2A, 0x00, 0x00,	// CHIP_MIC_CTRL      0000-0000 0000-0000
	0x00, 0x2C, 0x03, 0x22,	// CHIP_LINE_OUT_CTRL 0000-0011 0010-0010 LO_VAGCNTRL = 1.65V
	0x00, 0x2E, 0x06, 0x06,	// CHIP_LINE_OUT_VOL  0000-0110 0000-0110
	0x00, 0x34, 0x00, 0x00,	// CHIP_CLK_TOP_CTRL  0000-0000 0000-0000
	0x00, 0x38, 0x01, 0xC0,	// CHIP_ANA_TEST1     0000-0001 1100-0000
	0x01, 0x00, 0x00, 0x00,	// DAP_CONTROL        0000-0000 0000-0000

	// Setup PLL
	0x00, 0x32, 0x83, 0x12,	// CHIP_PLL_CTRL      1000-0011 0001-0010(16/786)
	// Power up analog modules (PLL/VGA/REF)
	0x00, 0x30, 0x47, 0x60,	// CHIP_ANA_POWER     0100-0111 0110-0000
};

static const uint8_t sf_audio_init_data2[] =
{
	// Power up analog modules (ALL)
//	0x00, 0x30, 0x47, 0xFF,	// CHIP_ANA_POWER     0100-0111 1111-1111
	0x00, 0x30, 0x47, 0xFA,	// CHIP_ANA_POWER     0100-0111 1111-1010
	// Power up digital modules
	0x00, 0x02, 0x00, 0x63,	// CHIP_DIG Power     0000-0000 0110-0011
	0x00, 0x04, 0x00, 0x0B,	// CHIP_CLK_CTRL      0000-0000 0000-1011
};

/* 1msPʃJE^ */
static uint32_t sf_1ms_counter;

/* tB^ON0, g[NX[0ȊO */
static int32_t sf_bypass_en;

/* DSPLinksŌW݌v
 * 
 * Remez Algorithm LPF
 * Sampling Frequency =    48000.0
 * cutoff1 =  500.0000000
 * cutoff2 = 2000.0000000
 * Tap Count = 112
 * attenuate =   -80.00
 * ripple factor =    0.1000000
 * Quantized by 32 [bits]
 */
static const fract32 s_fir_coeff[] = 
{
      215603,
      121856,
      143855,
      157083,
      156130,
      135067,
       86772,
        3752,
     -121953,
     -297660,
     -531404,
     -829603,
    -1197167,
    -1638046,
    -2152706,
    -2739534,
    -3393073,
    -4104290,
    -4859703,
    -5641591,
    -6427606,
    -7190697,
    -7899760,
    -8519506,
    -9011256,
    -9333763,
    -9443781,
    -9297463,
    -8851249,
    -8063451,
    -6895295,
    -5312641,
    -3287165,
     -797678,
     2168501,
     5614696,
     9533882,
    13908100,
    18708126,
    23893379,
    29412255,
    35202587,
    41192754,
    47302707,
    53445607,
    59529550,
    65459473,
    71139347,
    76474301,
    81372936,
    85749470,
    89525894,
    92633932,
    95016693,
    96630241,
    97444596,
    97444596,
    96630241,
    95016693,
    92633932,
    89525894,
    85749470,
    81372936,
    76474301,
    71139347,
    65459473,
    59529550,
    53445607,
    47302707,
    41192754,
    35202587,
    29412255,
    23893379,
    18708126,
    13908100,
     9533882,
     5614696,
     2168501,
     -797678,
    -3287165,
    -5312641,
    -6895295,
    -8063451,
    -8851249,
    -9297463,
    -9443781,
    -9333763,
    -9011256,
    -8519506,
    -7899760,
    -7190697,
    -6427606,
    -5641591,
    -4859703,
    -4104290,
    -3393073,
    -2739534,
    -2152706,
    -1638046,
    -1197167,
     -829603,
     -531404,
     -297660,
     -121953,
        3752,
       86772,
      135067,
      156130,
      157083,
      143855,
      121856,
      215603,
};

#define FIR_NUM_COEFFS		(sizeof(s_fir_coeff) / sizeof(fract32))

/* FIRtB^p[N */
static fir_state_fr32 s_fir_work[NUM_CHANNEL];
static fract32 s_fir_delay[NUM_CHANNEL][FIR_NUM_COEFFS];

static void s_bfin_clk_pll_set(uint8_t mul_val, uint8_t div_val)
{
	*pSIC_IWR = IWR_ENABLE(0);				/* PLL̂IWR */
	*pPLL_DIV = div_val;
	*pPLL_CTL = (mul_val) << 9;
	asm("cli r0; csync; idle; sti r0;": : :"R0");
	*pSIC_IWR = IWR_ENABLE_ALL;
}

/* w肳ꂽ}CNbҋ@ */
static void s_us_delay(uint32_t us)
{
	uint32_t l_start;
	uint32_t l_now;
	int32_t l_stop = us * (int32_t)(1000 / 2.5252525);	/* 1 cycle = 2.525..ns */

	asm("%0 = CYCLES;" : "=d"(l_start));
	while(1)
	{
		asm volatile("%0 = CYCLES;" : "=d"(l_now));
		if((l_now - l_start) >= l_stop)
			break;
	}
}

static void s_codec_init(void)
{
	uint32_t l_lc;

	/* CODEC҂(100ms) */
	s_us_delay(100000);

	/* SGTL5000 */
	for(l_lc = 0; l_lc < sizeof(sf_audio_init_data1); l_lc += 4)
	{
		/* SGTL5000WX^ݒ */
		s_twi_master_write(TWI_CODEC_DEVICE_ADDR, TWI_STOP, &sf_audio_init_data1[l_lc], 4);
		s_us_delay(1000); /* 莞ԑҋ@ */
	}
	/* PLL҂ */
	s_us_delay(100000);
	for(l_lc = 0; l_lc < sizeof(sf_audio_init_data2); l_lc += 4)
	{
		/* SGTL5000WX^ݒ */
		s_twi_master_write(TWI_CODEC_DEVICE_ADDR, TWI_STOP, &sf_audio_init_data2[l_lc], 4);
		s_us_delay(1000); /* 莞ԑҋ@ */
	}
}

void main(void)
{
	int32_t  l_dmabuf_idx;
	
	/* VR_CTLݒ */
	/* EXTCLK_OE = 1, EXTCLK_SEL = 0 */
	*pVR_CTL = EXTCLK_OE | HIBERNATEB;

	/* PLLݒ */
	/* CCLK 12Mhz * 33 = 396MHz */
	/* SCLK CCLK / 4   =  99MHz */
	s_bfin_clk_pll_set(33, 4);

	/* obt@NA */
	memset(sf_sport_rxbuf, 0 , sizeof(sf_sport_rxbuf));
	memset(sf_sport_txbuf, 0 , sizeof(sf_sport_txbuf));
	sf_sport_use_bufidx = 0;
	sf_data_incoming = 0;
	sf_1ms_counter = 0;
	sf_bypass_en = 0;
	
	/* FIRtB^p[N̏ */
	memset(s_fir_delay, 0, sizeof(s_fir_delay));
	fir_init(s_fir_work[0], (fract32*)s_fir_coeff, s_fir_delay[0], FIR_NUM_COEFFS, 0);
	fir_init(s_fir_work[1], (fract32*)s_fir_coeff, s_fir_delay[1], FIR_NUM_COEFFS, 0);
	
	/* |[g̐ݒ(SW) */
	*pPORTF_FER    &= ~PF0;
	*pPORTFIO_DIR  &= ~PF0;
	*pPORTFIO_INEN |=  PF0;
	
	/* |[g̐ݒ(LED) */
	*pPORTF_FER    &= ~PF4;
	*pPORTFIO_DIR  |=  PF4;
	*pPORTFIO_INEN &= ~PF4;
	*pPORTFIO_CLEAR =  PF4;
	
	/* |[g̐ݒ(SPORT1) */
	*pPORTF_MUX &= ~(PF1 | PF2 | PF3 | PF5 | PF6 | PF7); 
	*pPORTF_FER |= PF1 | PF2 | PF3 | PF5 | PF6 | PF7;

	/* TWI */
	s_twi_init();
	/* SGTL5000 */
	s_codec_init();
	
	/* GP^C}0̐ݒ */
	/* 1msPʂɊ荞݂悤ɐݒ */
	*pTIMER0_CONFIG = OUT_DIS | IRQ_ENA | PERIOD_CNT | PWM_OUT;
	*pTIMER0_PERIOD = SCLOCK_HZ / 1000;
	*pTIMER0_WIDTH = 1;
	*pTIMER_ENABLE = TIMEN0;
	/* 荞݃nhIVG11ɓo^ */
    register_handler(ik_ivg11, s_gptimer_isr);
	*pSIC_IMASK |= IRQ_TIMER0;

	/* SPORT RX̐ݒ */
	/* ONbNAOSYNCAMSB First */
	/* 24rbgf[^A XeI */
	*pSPORT1_RCR1 = RFSR | RCKFE;
	*pSPORT1_RCR2 = SLEN(31) | RSFSE;
	/* SPORT TX̐ݒ */
	/* ONbNAOSYNCAMSB First */
	/* 24rbgf[^A XeI */
	*pSPORT1_TCR1 = TFSR | TCKFE;
	*pSPORT1_TCR2 = SLEN(31) | TSFSE;

	/* DMA3(SPORT1 RX)̐ݒ */
	sf_sport_rxdma_desc[0].next_addr = (uint32_t)&sf_sport_rxdma_desc[1];
	sf_sport_rxdma_desc[0].addr      = (uint32_t)&sf_sport_rxbuf[0][0][0];
	sf_sport_rxdma_desc[0].cfg       = FLOW_LARGE | NDSIZE_9 | DI_EN | DMA2D | WDSIZE_32 | WNR | DMAEN;
	sf_sport_rxdma_desc[0].xcnt      = 2;
	sf_sport_rxdma_desc[0].xmod      = (int16_t)sizeof(int32_t) * NUM_SAMPLES * NUM_BUFFERS; // = sf_sport_rxbuf[1][0][0]
	sf_sport_rxdma_desc[0].ycnt      = NUM_SAMPLES;
	sf_sport_rxdma_desc[0].ymod      = ((int16_t)sizeof(int32_t) * -NUM_SAMPLES * NUM_BUFFERS) + (int16_t)sizeof(int32_t);

	sf_sport_rxdma_desc[1].next_addr = (uint32_t)&sf_sport_rxdma_desc[0];
	sf_sport_rxdma_desc[1].addr      = (uint32_t)&sf_sport_rxbuf[0][1][0];
	sf_sport_rxdma_desc[1].cfg       = FLOW_LARGE | NDSIZE_9 | DI_EN | DMA2D | WDSIZE_32 | WNR | DMAEN;
	sf_sport_rxdma_desc[1].xcnt      = 2;
	sf_sport_rxdma_desc[1].xmod      = (int16_t)sizeof(int32_t) * NUM_SAMPLES * NUM_BUFFERS; // = sf_sport_rxbuf[1][1][0]
	sf_sport_rxdma_desc[1].ycnt      = NUM_SAMPLES;
	sf_sport_rxdma_desc[1].ymod      = ((int16_t)sizeof(int32_t) * -NUM_SAMPLES * NUM_BUFFERS) + (int16_t)sizeof(int32_t);

	*pDMA3_PERIPHERAL_MAP = 0x3000;
	*pDMA3_NEXT_DESC_PTR = &sf_sport_rxdma_desc[0];
	*pDMA3_CONFIG = FLOW_LARGE | NDSIZE_9 | WNR;
	*pDMA3_X_COUNT = 0;
	*pDMA3_IRQ_STATUS = DMA_DONE | DMA_ERR;

	/* DMA4(SPORT1 TX)̐ݒ */
	sf_sport_txdma_desc[0].next_addr = (uint32_t)&sf_sport_txdma_desc[1];
	sf_sport_txdma_desc[0].addr      = (uint32_t)&sf_sport_txbuf[0][0][0];
	sf_sport_txdma_desc[0].cfg       = FLOW_LARGE | NDSIZE_9 | DI_EN | DMA2D | WDSIZE_32 | DMAEN;
	sf_sport_txdma_desc[0].xcnt      = 2;
	sf_sport_txdma_desc[0].xmod      = (int16_t)sizeof(int32_t) * NUM_SAMPLES * NUM_BUFFERS; // = sf_sport_rxbuf[1][0][0]
	sf_sport_txdma_desc[0].ycnt      = NUM_SAMPLES;
	sf_sport_txdma_desc[0].ymod      = ((int16_t)sizeof(int32_t) * -NUM_SAMPLES * NUM_BUFFERS) + (int16_t)sizeof(int32_t);

	sf_sport_txdma_desc[1].next_addr = (uint32_t)&sf_sport_txdma_desc[0];
	sf_sport_txdma_desc[1].addr      = (uint32_t)&sf_sport_txbuf[0][1][0];
	sf_sport_txdma_desc[1].cfg       = FLOW_LARGE | NDSIZE_9 | DI_EN | DMA2D | WDSIZE_32 | DMAEN;
	sf_sport_txdma_desc[1].xcnt      = 2;
	sf_sport_txdma_desc[1].xmod      = (int16_t)sizeof(int32_t) * NUM_SAMPLES * NUM_BUFFERS; // = sf_sport_txbuf[1][1][0]
	sf_sport_txdma_desc[1].ycnt      = NUM_SAMPLES;
	sf_sport_txdma_desc[1].ymod      = ((int16_t)sizeof(int32_t) * -NUM_SAMPLES * NUM_BUFFERS) + (int16_t)sizeof(int32_t);

	*pDMA4_PERIPHERAL_MAP = 0x4000;
	*pDMA4_NEXT_DESC_PTR = &sf_sport_txdma_desc[0];
	*pDMA4_CONFIG = FLOW_LARGE | NDSIZE_9;
	*pDMA4_X_COUNT = 0;
	*pDMA4_IRQ_STATUS = DMA_DONE | DMA_ERR;
	ssync();

	/* 荞݃nhIVG9ɓo^ */
    register_handler(ik_ivg9, s_sport_rx_isr);
	*pSIC_IMASK |= IRQ_DMA3;

	/* DMAL */
	*pDMA3_IRQ_STATUS = DMA_DONE;
	*pDMA3_CONFIG |= DMAEN;
	*pDMA4_CONFIG |= DMAEN;
	/* SPORT1L */
	*pSPORT1_TCR1 |= TSPEN;
	*pSPORT1_RCR1 |= RSPEN;
	ssync();

	while(1)
	{
		idle();
		if(0 != sf_data_incoming)
		{
			/* tONA */
			sf_data_incoming = 0;
			/* gpĂ悢obt@擾 */
			l_dmabuf_idx = sf_sport_use_bufidx ^ 1;
			s_audio_process(
				sf_sport_rxbuf[0][l_dmabuf_idx], sf_sport_rxbuf[1][l_dmabuf_idx],
				sf_sport_txbuf[0][l_dmabuf_idx], sf_sport_txbuf[1][l_dmabuf_idx]);
		}
	}
}

void s_audio_process(const int32_t* p_left_rxbuf, const int32_t* p_right_rxbuf, int32_t* p_left_txbuf, int32_t* p_right_txbuf)
{
	if(sf_bypass_en == 0)
	{
		/* FIRtB^s */
		fir_fr32((const fract32*)p_left_rxbuf,  (fract32*)p_left_txbuf,  NUM_SAMPLES, &s_fir_work[0]);
		fir_fr32((const fract32*)p_right_rxbuf, (fract32*)p_right_txbuf, NUM_SAMPLES, &s_fir_work[1]);
	}
	else
	{
		/* Mobt@̃f[^𑗐Mobt@ɃRs[(oCpXErp) */
		memcpy(p_left_txbuf,  p_left_rxbuf,  NUM_SAMPLES * sizeof(int32_t));
		memcpy(p_right_txbuf, p_right_rxbuf, NUM_SAMPLES * sizeof(int32_t));
	}
}

/* SPORT RX DMA荞݃nh */
EX_INTERRUPT_HANDLER(s_sport_rx_isr)
{
	*pDMA3_IRQ_STATUS = DMA_DONE;
	ssync();
	/* I[fBIR[fbNf[^ */
	sf_data_incoming = 1;
	/* DMAgpobt@ύX */
	sf_sport_use_bufidx = (sf_sport_use_bufidx ^ 1) & 1;
}

/* TWI(I2C) */
void s_twi_init(void)
{
	*pTWI_CONTROL = 0;
	ssync();
	*pTWI_CONTROL = TWI_ENA | 10U;
	*pTWI_CLKDIV  = CLKHI(8) | CLKLOW(17);
	*pTWI_INT_MASK = RCVSERV | XMTSERV | MERR | MCOMP;
	*pTWI_INT_STAT = *pTWI_INT_STAT;
	*pTWI_FIFO_CTL = XMTFLUSH | RCVFLUSH;
	ssync();
}

int32_t s_twi_master_write(uint8_t slave_addr, int32_t rstart, const uint8_t* p_data, int32_t write_cnt)
{
	int32_t l_idx;
	
	if(write_cnt <= 0)
	{
		return NO_ERROR;
	}

	*pTWI_FIFO_CTL = 0;
	*pTWI_INT_STAT = *pTWI_INT_STAT;
	*pTWI_MASTER_STAT = BUFWRERR | BUFRDERR | LOSTARB | ANAK | DNAK | FAST;
	*pTWI_MASTER_ADDR = slave_addr;
	// Send first byte
	*pTWI_XMT_DATA8 = p_data[0];
	*pTWI_MASTER_CTL = TWI_COUNT(write_cnt) | MEN | (rstart ? RSTART : 0);
	ssync();

	for(l_idx = 1; l_idx < write_cnt; l_idx++)
	{
		while(((*pTWI_INT_STAT & MERR) == 0U) && (*pTWI_FIFO_STAT == XMTSTAT)) ssync();
		*pTWI_XMT_DATA8 = p_data[l_idx];
		ssync();
	}

	/* ]I܂őҋ@ */
	while((*pTWI_INT_STAT & MCOMP) == 0U) ssync();
	if((*pTWI_INT_STAT & MERR) == 0U)
	{
		return NO_ERROR;
	}
	else
	{
		return TWI_ERROR_NAK;
	}
}

EX_INTERRUPT_HANDLER(s_gptimer_isr)
{
	static uint32_t l_1ms_cnt = 0;
	/* XCb`̏ */
	static uint16_t l_sw_state = 0;
	static uint16_t l_sw_sample = 0;
	uint16_t l_sw_state_prev;
	uint16_t l_sw_sample_prev;
	uint16_t l_sw_change_bit;

	/* 荞݃Xe[^X̍XV */
	*pTIMER_STATUS = TIMIL0;
	ssync();
	
	/* JE^CNg */
	sf_1ms_counter++;

	/* 10msɃXCb`̏Ԃ`FbN */
	if((int32_t)(sf_1ms_counter - l_1ms_cnt) > 10)
	{
		/* ÕTvOԂۑ */
		l_sw_sample_prev = l_sw_sample;
		l_sw_state_prev  = l_sw_state;
		/* XCb`̏ԂTv */
		l_sw_sample = ~*pPORTFIO & PF0;
		/* XCb`̏ԂXV */
		l_sw_state  = l_sw_sample & ~(l_sw_sample ^ l_sw_sample_prev);
		/* ω̂rbg擾 */
		l_sw_change_bit = l_sw_state ^ l_sw_state_prev;

		/* XCb`̏ԂɍďLEDω */
		if((l_sw_change_bit & PF0) && (l_sw_state & PF0))
		{
			sf_bypass_en = !sf_bypass_en;
			if(sf_bypass_en == 0)
				*pPORTFIO_CLEAR = PF4;
			else
				*pPORTFIO_SET = PF4;
		}

		l_1ms_cnt = sf_1ms_counter;
	}
}

